#if !defined MSG_REQUESTLEXER_HH_
#define MSG_REQUESTLEXER_HH_

#include <string>

#include <boost/regex.hpp>

#include <default-lexer.hh>
#include <ontology-lexer.hh>

using namespace std;

// ---------- String tools ----------

static string& str_replace(const string &search, const string &replace, string &subject) {
    string buffer;
    int sealeng = search.length();
    int strleng = subject.length();
    if (sealeng==0) return subject;
    for(int i=0, j=0; i<strleng; j=0 ) {
        while (i+j<strleng && j<sealeng && subject[i+j]==search[j]) j++;
        if (j==sealeng) {buffer.append(replace); i+=sealeng;}
        else buffer.append( &subject[i++], 1);
    }
    subject = buffer;
    return subject;
}

static string& removeFormatting(string &s) {
	return str_replace(" ", "", s);
}

#endif
